<?

   $_debug_input = true;
   
   function GetCoordinate($m, $dms_d, $dms_m, $dms_s, $dm_d, $dm_m, $dd)
   {
     $r = 0;

     if(strlen($m[$dd])) $r = $m[$dd];
     
     if(strlen($m[$dm_d])) $r = $m[$dm_d];
     if(strlen($m[$dm_m])) $r += $m[$dm_m] / 60;

     if(strlen($m[$dms_d])) $r = $m[$dms_d];
     if(strlen($m[$dms_m])) $r += $m[$dms_m] / 60;
     if(strlen($m[$dms_s])) $r += $m[$dms_s] / 3600;
     
     return $r;
   }
   
   function CorrectSign($val, $sign)
   {
     if($sign == "W" || $sign == "S") $val = -$val;
     return($val);
   }


  function get_coordinates($q)
  {
  /* Group spaces, commas etc. */
    $q = preg_replace('/[\s,]+/', ' ', $q);
    $q = trim($q);
    
    /* Regexp */
    
    $re  = '/^([NSEW])?\s*'; /* Starts with sign */
    $re .= '((([+-]?[0-9]+(\.[0-9]+)?)[°d]*)';	/* First number as (+-)NN.NNN */
    $re .=  '|(([0-9]+)[\s°d]+(([0-9]+(\.[0-9]+)?)[m\'′]*))';	/* First number as NN NN.NNN */
    $re .=  '|(([0-9]+)[\s°d]+([0-9]+)[m\s\'′]+([0-9]+(\.[0-9]+)?)[s"]*)';	/* First number as NN NN NN.NNN */
    $re .= ')';
    $re .= '(\s+|\s*([NSEW])\s*)'; /* Sign or separator */
    $re .= '((([+-]?[0-9]+(\.[0-9]+)?)[°d]*)';	/* Second number as (+-)NN.NNN */
    $re .=  '|(([0-9]+)[\s°d]+(([0-9]+(\.[0-9]+)?)[m\'′]*))';	/* Second number as NN NN.NNN */
    $re .=  '|(([0-9]+)[\s°d]+([0-9]+)[m\s\'′]+([0-9]+(\.[0-9]+)?)[s"]*)';	/* Second number as NN NN NN.NNN */
    $re .= ')';
    $re .= '\s*([NSEW])?$/'; /* Sign */

    $m = array();
    if(preg_match($re, $q, $m))
    {
      /* Legend to parenthesis:
        1 - Left sign (NEWS)
        17 - Middle sign (NEWS)
        32 - Right sign (NEWS)
        
        First coordinate:
        DD MM SS : 12 - 13 - 14
        DD MM.MMM: 7 - 9
        +-DD.DDD:  4
        
        Second coordinate:
        DD MM SS:  28 - 29 - 30
        DD MM.MMM  23 - 25
        +-DD.DDD:  20
       */ 
       
       
       $n1 = GetCoordinate($m, 12, 13, 14, 7, 9, 4);
       $n2 = GetCoordinate($m, 28, 29, 30, 23, 25, 20);
       
       if(strlen($m[1]))
       {
         $sign1 = $m[1];
         $sign2 = strlen($m[17]) ? $m[17] : $m[32];
       }
       else if(strlen($m[17]))
       {
         $sign1 = $m[17];
         $sign2 = $m[32];
       }
       
       $n1 = CorrectSign($n1, $sign1);
       $n2 = CorrectSign($n2, $sign2);
       
       if($sign1 == "E" || $sign1 == "W")
         { $lon = $n1; $lat = $n2; }
       else
         { $lon = $n2; $lat = $n1; }
      
      $lat = round($lat, 6);
      $lon = round($lon, 6);
      if($lat > 90 || $lat < -90) return(false);
      if($lon < -180 || $lon > 180) return(false);
      return(array("lat" => $lat, "lon" => $lon));
    }
    return(false);
  }
  
  function select_utm_zone($lat, $lon)
  {
      $zone = (int) ( ( $lon + 180 ) / 6 ) + 1;
      if ( $lat >= 56.0 && $lat < 64.0 && $lon >= 3.0 && $lon < 12.0 ) { $zone = 32; }

      if ($lat >= 72.0 && $lat < 84.0 )
      {
          if ( $lon >= 0.0 && $lon < 9.0 )
              $zone = 31;
          else if ( $lon >= 9.0 && $lon < 21.0 )
              $zone = 33;
          else if ( $lon >= 21.0 && $lon < 33.0 )
              $zone = 35;
          else if ( $lon >= 33.0 && $lon < 42.0 )
              $zone = 37;
      }      
      return($zone);
  }
  
  function fail($msg)
  {
    if(php_sapi_name() == "cli")
    {
      fwrite(STDERR, $msg . "\n");
      die();
    }
    else
      die($msg);
  }

  function load_lines($limit = 262144, $file = "file", $data = "data", $fname = "php://stdin")
  {
    if(php_sapi_name() == "cli")
    {
      $fh = fopen($fname, "r");
      $lines = array();
      while($l = fgets($fh))
        $lines[] = $l;
      fclose($fh);
    }
    else
    {
      $data = $_REQUEST[$data];

      if(file_exists($fname = $_FILES[$file]["tmp_name"]))
        $data = file_get_contents($fname);

      if(strlen($data) > $limit) fail("Błąd: zbyt duże dane wejściowe (limit: {$limit} bajtów)\r\nError: Input data too large.");

      $lines = explode("\n", $data);
    }
    if(!count($lines))
      fail("Błąd: Nie wczytano żadnych danych wejściowych\r\nError: No input data loaded.");
    return($lines);
  }
  
  function Det($m)
  {
    if(count($m) == 1) return($m[0][0]);
    if(count($m) == 2) return($m[0][0] * $m[1][1] - $m[1][0] * $m[0][1]);
    if(count($m) == 3) 
      return($m[0][0] * $m[1][1] * $m[2][2] + 
             $m[0][1] * $m[1][2] * $m[2][0] + 
             $m[0][2] * $m[1][0] * $m[2][1] -
             $m[2][0] * $m[1][1] * $m[0][2] -
             $m[2][1] * $m[1][2] * $m[0][0] -
             $m[2][2] * $m[1][0] * $m[0][1]);
    
    $sum = 0;
    for($i = 0; $i<count($m); $i++)	/* Row by row */
    {
      $s = array();
      for($x = 1; $x<count($m); $x++)
        for($y = 0; $y<count($m); $y++)
          {
            if($y == $i) continue;
            $s[$x - 1][$y < $i ? $y : ($y - 1)] = $m[$x][$y];
          }

      $sum += (($i % 2 == 0) ? 1 : -1) * $m[0][$i] * Det($s);
    }
    return $sum;
  }

  
  function CalcSumFacts($pairs, $key1, $key2 = "")
  {
    $S = 0;
    foreach($pairs as $ent)
      $S += $ent[$key1] * ($key2 ? $ent[$key2] : 1);
    return $S;
  }

  function FindCalibrationMatrix($pairs, $zi = "x", $xi = "lat", $yi = "lon")
  {
    /* Least square approach */
    /* Przygotowujemy układ równań  */
    $A = count($pairs);
    $B = CalcSumFacts($pairs, $xi);
    $C = CalcSumFacts($pairs, $yi);
    $D = CalcSumFacts($pairs, $zi);
    
    $E = $B;
    $F = CalcSumFacts($pairs, $xi, $xi);
    $G = CalcSumFacts($pairs, $xi, $yi);
    $H = CalcSumFacts($pairs, $xi, $zi);
    
    $I = $C;
    $J = $G;
    $K = CalcSumFacts($pairs, $yi, $yi);
    $L = CalcSumFacts($pairs, $yi, $zi);
    
    /* Rozwiązujemy układ równań */
    $W  = $A * $F * $K + $E * $J * $C + $I * $B * $G - $C * $F * $I - $G * $J * $A - $K * $B * $E;
    $Wa = $D * $F * $K + $H * $J * $C + $L * $B * $G - $C * $F * $L - $G * $J * $D - $K * $B * $H;
    $Wb = $A * $H * $K + $E * $L * $C + $I * $D * $G - $C * $H * $I - $G * $L * $A - $K * $D * $E;
    $Wc = $A * $F * $L + $E * $J * $D + $I * $B * $H - $D * $F * $I - $H * $J * $A - $L * $B * $E;
    
    return array("a" => $Wa / $W, "b" => $Wb / $W, "c" => $Wc / $W);
  }
  
  function FindCalibrationMatrixA($pairs, $zi = "x", $xi = "lat", $yi = "lon")
  {
    /* If we have points: 1 ... N, then 
       Variables matrix is:
        a*1 b*xi c*yi d*(dist to point3) ... x*(dist to pointN)
        a*1 b*xi c*yi d*(dist to point3) ... x*(dist to pointN)
        ... and so on (N equations)
       
    */
    $N = count($pairs); $b = array();
    for($i = 0; $i<$N; $i++)
    {
      $e = $pairs[$i];
      $b[$i] = array(0 => 1, 1 => $e[$xi], 2 => $e[$yi]);
      for($j = 3; $j<$N; $j++)
        $b[$i][$j] = sqrt(pow($e[$xi] - $pairs[$j][$xi], 2) + pow($e[$yi] - $pairs[$j][$yi], 2));
    }
    $W = Det($b); $r = array();
    for($i = 0; $i < $N; $i++)
    {
      $m = $b;
      for($j = 0; $j < $N; $j++)
        $m[$j][$i] = $pairs[$j][$zi];
        
      $Wx = Det($m);
      $r[$i] = $Wx / $W;
    }
    return($r);
  }
  
  function DeprojectPoint($a, $b, $m, $pairs, $xi = "lat", $yi = "lon")
  {
    $N = count($pairs);
    $r = $m[0] + $m[1] * $a + $m[2] * $b;
    for($i = 3; $i<$N; $i++)
      $r += $m[$i] * sqrt(pow($a - $pairs[$i][$xi], 2) + pow($b - $pairs[$i][$yi], 2));
    return $r;
  }

  function ParseCal_Cal($lines, $separator = "\t", $inverse = false)
  {
    $cals = array();
    foreach($lines as $l)
    {
      if(!strlen(trim($l))) continue;
      if($inverse)
        list($lat, $lon, $x, $y) = explode($separator, trim($l));      
      else
        list($x, $y, $lat, $lon) = explode($separator, trim($l));
      $x = trim(strtr($x, ",", "."));
      $y = trim(strtr($y, ",", "."));
      $lat = trim(strtr($lat, ",", "."));
      $lon = trim(strtr($lon, ",", "."));
      if(!is_numeric($x)) continue;
      if(!is_numeric($y)) continue;
      if(!is_numeric($lat)) continue;
      if(!is_numeric($lon)) continue;
      
      $cals[] = array("x" => $x, "y" => $y, "lat" => $lat, "lon" => $lon);
    }
    return $cals;
  }
  
  /* From the GeoPoint class by Brenor Brophy (GPL) */
  // Written by Chuck Gantz- chuck dot gantz at globalstar dot com, converted to PHP by
  // Brenor Brophy, brenor dot brophy at gmail dot com
  // Adapted by Mateusz Golicz mateusz dot golicz at pza dot org dot pl
  
  function ll2utm($lat, $lon, $ZoneNumber = false)
  {
    /* WGS84 datum parameters */
    static $a = 6378137, $e2 = 0.00669438, $k0 = 0.9996;
   
    if($lat > 1000 && $lon > 1000)	/* Already projected */
      return(array($lon, $lat, $ZoneNumber));
    
    $LatRad = deg2rad($lat);
    $LongRad = deg2rad($lon);

    if($ZoneNumber === false) $ZoneNumber = select_utm_zone($lat, $lon);
    $LongOrigin = ($ZoneNumber - 1)*6 - 180 + 3; 
    $falseEasting = 500000.0;
    
    $LongOriginRad = deg2rad($LongOrigin);
    $eccPrimeSquared = ($e2)/(1-$e2);
    $N = $a/sqrt(1-$e2*sin($LatRad)*sin($LatRad));
    $T = tan($LatRad)*tan($LatRad);
    $C = $eccPrimeSquared*cos($LatRad)*cos($LatRad);
    $A = cos($LatRad)*($LongRad-$LongOriginRad);

    $M = $a*((1	- $e2/4 - 3*$e2*$e2/64  - 5*$e2*$e2*$e2/256)*$LatRad 
   	   - (3*$e2/8	+ 3*$e2*$e2/32	+ 45*$e2*$e2*$e2/1024)*sin(2*$LatRad)
  	   + (15*$e2*$e2/256 + 45*$e2*$e2*$e2/1024)*sin(4*$LatRad) 
	   - (35*$e2*$e2*$e2/3072)*sin(6*$LatRad));
	
    $x = ($k0*$N*($A+(1-$T+$C)*$A*$A*$A/6
	+ (5-18*$T+$T*$T+72*$C-58*$eccPrimeSquared)*$A*$A*$A*$A*$A/120)
	+ $falseEasting);

    $y = ($k0*($M+$N*tan($LatRad)*($A*$A/2+(5-$T+9*$C+4*$C*$C)*$A*$A*$A*$A/24
	+ (61-58*$T+$T*$T+600*$C-330*$eccPrimeSquared)*$A*$A*$A*$A*$A*$A/720)));
    
    if($lat < 0)
	$y += 10000000.0;
    
    return(array($x, $y, $ZoneNumber));
  }

  // Written by Chuck Gantz- chuck dot gantz at globalstar dot com, converted to PHP by
  // Brenor Brophy, brenor dot brophy at gmail dot com
  // Adapted by Mateusz Golicz mateusz dot golicz at pza dot org dot pl

  function utm2ll($x, $y, $ZoneNumber)
  {
    /* WGS84 datum parameters */
    static $a = 6378137, $e2 = 0.00669438, $k0 = 0.9996;

    $e1 = (1-sqrt(1-$e2))/(1+sqrt(1-$e2));

    $LongOrigin = ($ZoneNumber - 1)*6 - 180 + 3;
    $falseEasting = 500000.0;
    $x -= $falseEasting;

    $eccPrimeSquared = ($e2)/(1-$e2);

    $M = $y / $k0;
    $mu = $M/($a*(1-$e2/4-3*$e2*$e2/64-5*$e2*$e2*$e2/256));

    $phi1Rad = $mu	+ (3*$e1/2-27*$e1*$e1*$e1/32)*sin(2*$mu) 
      		        + (21*$e1*$e1/16-55*$e1*$e1*$e1*$e1/32)*sin(4*$mu)
      		        + (151*$e1*$e1*$e1/96)*sin(6*$mu);
    $phi1 = rad2deg($phi1Rad);

    $N1 = $a/sqrt(1-$e2*sin($phi1Rad)*sin($phi1Rad));
    $T1 = tan($phi1Rad)*tan($phi1Rad);
    $C1 = $eccPrimeSquared*cos($phi1Rad)*cos($phi1Rad);
    $R1 = $a*(1-$e2)/pow(1-$e2*sin($phi1Rad)*sin($phi1Rad), 1.5);
    $D = $x/($N1*$k0);

    $tlat = $phi1Rad - ($N1*tan($phi1Rad)/$R1)*($D*$D/2-(5+3*$T1+10*$C1-4*$C1*$C1-9*$eccPrimeSquared)*$D*$D*$D*$D/24
                     +(61+90*$T1+298*$C1+45*$T1*$T1-252*$eccPrimeSquared-3*$C1*$C1)*$D*$D*$D*$D*$D*$D/720); // fixed in 1.1
    $lat = rad2deg($tlat);

    $tlong = ($D-(1+2*$T1+$C1)*$D*$D*$D/6+(5-2*$C1+28*$T1-3*$C1*$C1+8*$eccPrimeSquared+24*$T1*$T1)
		*$D*$D*$D*$D*$D/120)/cos($phi1Rad);
    $lon = $LongOrigin + rad2deg($tlong);
    
    return(array($lat, $lon));
  }


?>