<?
  function parse_bounds($bound_p1, $bound_p2)
  {
    if($bound_p1 || $bound_p2) 
    {
      if(!($bound_p1 && $bound_p2))
        fail("Jeśli wybrano ograniczanie, należy wskazać dwa punkty ograniczające obszar zainteresowania");
      
      $bound_p1 = preg_replace('/[\s:;]+/', ' ', $bound_p1);
      $bound_p2 = preg_replace('/[\s:;]+/', ' ', $bound_p2);
      list($y1, $x1) = explode(" ", $bound_p1);
      list($y2, $x2) = explode(" ", $bound_p2);
      $b = array("min" => array("x" => $x1, "y" => $y1), "max" => array("x" => $x1, "y" => $y1));
      foreach(array("x1", "x2", "y1", "y2") as $v)
      {
        $$v = trim(strtr($$v, array("," => ".")));
        if(!is_numeric($$v)) fail("Niewłaściwa współrzędna punktu ograniczającego (" . $$v . ")");
        foreach(array("min", "max") as $f)
        {
          $b[$f][$v[0]] = $f($b[$f][$v[0]], $$v);
        }
      } 
    }
    return($b);
  }
  
  function do_bound($b, $fname, $dem_path, $err_path)
  {
    $cmd = "gdal_translate -projwin " . $b["min"]["x"] . " " . $b["max"]["y"] . " " . $b["max"]["x"] . " " . $b["min"]["y"] . " {$fname} {$dem_path}";
    system("{$cmd} >{$err_path} 2>&1");
    if(!file_exists($dem_path))
    {
      $emsg = file_get_contents($err_path);
      @unlink($err_path); @unlink($dem_path);
      fail("Błąd: Błąd ograniczania modelu terenu: " . $emsg);
    }

  }
  

 function finish_pset($a, $fmt, $zone = false)
  {
    static $pnum = 0, $ctrid = 0;
    
    if(count($a) < 2) return;

    if($pnum > 500000)
      return;
    
    list($py, $px, $pelev) = array_shift($a);
    if($fmt[0] == "u") list($px, $py, $zone) = ll2utm($py, $px, $zone);

    $pnum_start = $pnum;

    if($fmt == "usvx" || $fmt == "umsh")
      echo "*fix {$pnum} {$px} {$py} {$pelev}\r\n";
    else if($fmt == "usrv")
      echo "#fix CNT:{$pnum} {$px} {$py} {$pelev}\r\n";
    else
      echo "{$ctrid};{$px};{$py};{$pelev}\r\n";
    
    $pnum++;
    
    foreach($a as $p)
    {
      list($y, $x, $elev) = $p;
      if($fmt[0] == "u") { list($x, $y, $zone) = ll2utm($y, $x, $zone);  }
      
      
      
      if($fmt == "usvx" || $fmt == "usrv")
        echo sprintf("%d %d %.4f %.4f %.4f\n", $pnum - 1, $pnum, $x - $px, $y - $py, $elev - $pelev);
      else if($fmt == "umsh")
        echo sprintf("*fix %d %.4f %.4f %.4f\n", $pnum, $x, $y, $elev);
      else if($fmt == "uicsv")
        echo sprintf("%d;%.4f;%.4f;%.4f\n", $ctrid, $x - $px, $y - $py, $elev - $pelev);
      else if($fmt == "licsv")
        echo sprintf("%d;%.4f;%.4f;%.4f\n", $ctrid, $x - $px, $y - $py, $elev - $pelev);
      else if($fmt == "uacsv")
        echo sprintf("%d;%.2f;%.2f;%.2f\n", $ctrid, $x, $y, $elev);
      else
        echo sprintf("%d;%.6f;%.6f;%.2f\n", $ctrid, $x, $y, $elev);
      
      $px = $x; $py = $y; $pelev = $elev;
     $pnum++;
    }
    
    if($fmt == "umsh")
      for($j = $pnum_start; $j<$pnum; $j++)
        echo $j . "\r\n";
    
    echo "\r\n";
    $ctrid++;
  }

  function write_header($format)
  {
    if($format == "usvx" || $format == "umsh")
    {
      echo "*begin surface\r\n";
      echo "*flags splay\r\n";
      if($format == "umsh")
        echo "*data nosurvey station\r\n";
      else
        echo "*data cartesian from to easting northing altitude\r\n";
    }
    else if($format == "usrv")
    {
      echo "#units rect order=ENU\r\n";
      echo "#units meters\r\n";
      echo "#prefix CNT\r\n";
    }
  }
  
  function write_footer($format)
  {
    if($format == "usvx" || $format == "umsh")
      echo "*flags not splay\r\n*end surface\r\n";
  }


  function write_elev_header($format, $elev)
  {
    $elev = intval($elev);
    if($format == "usvx" || $format == "umsh")
      echo "*begin elev_{$elev}\r\n";
  }

  function write_elev_footer($format, $elev)
  {
    $elev = intval($elev);
    if($format == "usvx" || $format == "umsh")
      echo "*end elev_{$elev}\r\n";
  }


 ?>