<?
  require_once "common.php";
  header("Content-type: text/plain; charset=utf-8");
  
  if(php_sapi_name() == "cli")
  {    
    $opt = getopt("wh");
    
    if(isset($opt["w"]))
      $mode = "SRV";
    else
      $mode = "SVX";

    if(isset($opt["h"]))
    {
      echo "pt2svx.php - Convert PocketTopo text export into Survex or Walls\r\n";
      echo "             (C) 2012 - 2013 Mateusz 'mteg' Golicz <mateusz.golicz@pza.org.pl>\r\n";
      echo "\r\n";
      echo "Usage: pt2svx.php [-w]\r\n";
      echo "\r\n";
      echo "Options:\r\n";
      echo "  -w      Use Walls output format (default: Survex)\r\n";
      echo "\r\n";
      echo "The program expects its standard input to contain a text export from PocketTopo (Export / Text) of measurement data.";
      echo "On the standard output, a corresponding Survex or Walls file is produced.\r\n";
      
      exit;
    }

  }
  else
    $mode = $_REQUEST["mode"];


  if(!$mode)
    $mode = "SVX";
  
  $out = "";
  if($mode == "SVX")
  {
    $out .= "*begin cave\r\n";
  
    $out .= "*team \"...\" notes\r\n";
    $out .= "*team \"...\" compass clino tape\r\n";
    $out .= "*date " . date("Y.m.d") . "\r\n";

    $out .= "*data normal from to tape compass clino\r\n";
  }
  else
  {
    $out .= "#units meters order=DAV\r\n";
    $out .= "#units A=D V=D\r\n";
    $out .= "#prefix cave\r\n";
    $out .= "#date " . date("Y-m-d") . "\r\n";
  }
  
  $out .= "\r\n";

  $centerline = array();
  $splay = array();
  
  $lines = load_lines();

  foreach($lines as $l)
  {
    if(!strlen($l)) continue;
    $from = trim(substr($l, 0, 13));
    $to = trim(substr($l, 13, 25 - 18 + 2));
    $tape = trim(substr($l, 25, 32 - 25));
    $compass = trim(substr($l, 34, 41 - 34));
    $clino = trim(substr($l, 42, 50 - 42));

//    echo "read: f = $from to = $to tape = $tape compass = $compass clino = $clino\n";
    
    if(!preg_match('/^[0-9]+\.[0-9]+$/', $from)) continue;
    if(!(preg_match('/^[0-9]+\.[0-9]+$/', $to) || $to == "")) continue;
    
    $from = preg_replace('/\./', '_', $from);
    $to = preg_replace('/\./', '_', $to);
    

    if($to)
      $centerline[$from][$to][] = array($compass, $clino, $tape);
    else
      $splay[$from][] = array($compass, $clino, $tape);
    
    
  }

  foreach($centerline as $from => $i)
    foreach($i as $to => $j)
    {
      $n = 0; $compass = 0; $clino = 0; $tape = 0;
      foreach($j as $ent)
      {
        $n++;
        $compass += $ent[0]; $clino += $ent[1]; $tape += $ent[2];
      }
      $compass /= $n; $clino /= $n; $tape /= $n;
      $compass = round($compass, 2);
      $clino = round($clino, 2);
      $tape = round($tape, 4);
      
      $out .= "$from\t$to\t$tape\t$compass\t$clino\r\n";
    }
    
    
    if(count($splay))
    {
      if($mode == "SVX")
        $out .= "*flags splay\r\n";
    
      foreach($splay as $from => $splays)
        foreach($splays as $sid => $i)
          $out .= "$from\t" . ($mode == "SVX" ? "{$from}S{$sid}" : "-") . "\t" . $i[2] . "\t" . $i[0] . "\t" . $i[1] . "\r\n";
    
      if($mode == "SVX")
        $out .= "*flags not splay\r\n";
    }
    if($mode == "SVX")
     $out .= "*end cave\r\n";
  
    echo $out;
?>